//-----------------------------------------------------------------------------
// Freeware.  This file may be used freely to promote the ioctl90 mixer API.
//-----------------------------------------------------------------------------

// mixerapiOC.c

/* Created from mixerapi.c by Lesha Bogdanow:
   Removed fprintfs, added check for CALLBACKREG function presence,
   Moved PddName[] to global vars, modified to autodetect only if not set initially
   Converted to open-IOCTL-close mode
*/

#include <stdlib.h>
#include <stdio.h>
#include <process.h>
#include <signal.h>
#include <memory.h>
#include <string.h>
#include <ctype.h>
#include <io.h>

#define USE_OS2_TOOLKIT_HEADERS
#define INCL_DOSPROCESS      // DosSleep
#define INCL_DOSDEVICES      // DosDevIOCtl 
#define INCL_DOSFILEMGR      // DosDevIOCtl 
#define INCL_DOSSEMAPHORES   // Semaphore values
#define INCL_DOSDATETIME     // Timer support
#define INCL_DOSERRORS       // DOS error values
#include <os2.h>

#include "pddname.h"
#include "ioctl90.h"
#include "mixerapi.h"

HFILE hDriver = 0;
NPFN  CallbackFunc = NULL;
HEV   hevCallback = 0;
BOOL  fCallbackThreadAlive = FALSE;
char  szPddName [14]="\0";  // "\\DEV\\12345678"

HFILE DevOpen (char *ddName)
{
   ULONG ulRC;
   ULONG OpenFlags;
   ULONG OpenMode;
   ULONG ulFileSize      = 0;
   ULONG ulFileAttribute = 0;
   ULONG ulActionTaken   = 0;
   HFILE hPdd            = 0;

   OpenFlags = OPEN_ACTION_OPEN_IF_EXISTS;   // Do not create file

   OpenMode  = OPEN_ACCESS_READWRITE +       // Read/Write file
               OPEN_SHARE_DENYNONE +         // Non-exclusive access
               OPEN_FLAGS_FAIL_ON_ERROR;     // No system popups on errors

   ulRC = DosOpen (ddName,          // in
                   &hPdd,           //    out (handle)
                   &ulActionTaken,  //    out
                   ulFileSize,      // in
                   ulFileAttribute, // in
                   OpenFlags,       // in
                   OpenMode,        // in
                   NULL);           // in

   if (ulRC != 0)
      hPdd = 0;

   return (hPdd);
}


ULONG mixerapiIOCTL90 (USHORT usFunc, PVOID pv, ULONG ulSizeofPV)
{
   ULONG ulRC;
   ULONG ulSize;
   HFILE hDriver;

   hDriver = DevOpen (szPddName);
   if (!hDriver) return 1;

   ulSize = ulSizeofPV;

   ulRC = DosDevIOCtl 
      (hDriver,            // Device Handle
       0x90,               // Category (user defined >= 0x80)
       usFunc,             // Function (User defined function >= 0x40)
       NULL,               // in      Address of parm data (not used)
       0,                  // in      Max size of parm data structure
       NULL,               // in out  Actual size of parm data structure
       pv,                 // in      Address of command data
       ulSize,             // in      Maximum size of command data
       &ulSize);           // in out  Size of command data returned
   DosClose (hDriver);
   return (ulRC);
}


void mixerapiDeInit (void)
{

// Dummy

return;
}


ULONG mixerapiInit (NPFN npfnCallback)
{
   ULONG    ulRC;
   unsigned char ApiMap[256];
   HFILE hDriver;

   if (!*szPddName) {
      strcpy (szPddName, "\\DEV\\");
      ulRC = GetAudioPDDName (&szPddName[5]);
      if (ulRC != 0) return (ulRC);
      }

   hDriver = DevOpen (szPddName);

   if (hDriver == 0) ulRC = 1;
   else {
      ulRC=mixerapiIOCTL90(GETAPIMAP,ApiMap,256);
      DosClose (hDriver);
      }
   return (ulRC);
}
