/* 

LBMix - A mixer for IOCTL90 API by Lesha Bogdanow
Copyright (C) 1999-2000  Lesha Bogdanow

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/


// This file contain very generic routines related to PM and GPI

// Window ID of a scrollbar in a listbox (undocumented)
#define LID_SCROLLBAR 0xC001

// Additional colors
#define RGB_LIGHTGRAY 0xCCCCCC
#define RGB_DARKGRAY 0x808080

// Mix RGB colors c1 and c2 in i1 to i2 proportion
LONG RGBMix(LONG c1, int i1, LONG c2, int i2);

// Query presentation parameters of a window. Return NULL if no specific
// presentation parameters are present
// returns NULL if hwnd==NULLHANDLE
PPRESPARAMS QueryWinPP(HWND hwnd);

/* Strip specified parameter from the PRESPARAMS structure. Returns NULL
   if pp is NULL or the parameter removed was the only one */
PPRESPARAMS StripPP(PPRESPARAMS pp, ULONG id);

// Set presentation parameters for a window.
// NOP if either hwnd or pp is NULL
void SetWinPP(HWND hwnd, PPRESPARAMS pp);

// Load binary data of specified size from profile. Return TRUE if Ok
int  LoadPrfBin(HINI hini,const char *app,const char *key, void *data, ULONG l);

// Allocate memory and load data from profile. Return NULL if
// no data loaded
void *LoadPrfData(HINI hini,const char *app,const char *key, ULONG *len);

// Save presentation parameters to profile
void SavePP(HINI hini,const char *app,const char *key, PPRESPARAMS pp);

// Allocate memory and load presentation parameters from profile
PPRESPARAMS LoadPP(HINI hini,const char *app,const char *key);
