/* Update from older versions of LBMix by Lesha Bogdanow */

call RxFuncAdd "SysIni","RexxUtil","SysIni"
INI="LBMix.ini"

Suffix.1="Left"
Suffix.2="Right"
Suffix.3="Mute"
Suffix.4="Both"
Suffix.5="Lock"
Suffix.6="Active"
Suffix.7="Name"
Suffix.8="PPGroup"
Suffix.9="PPLeft"
Suffix.10="PPRight"
Suffix.11="PPBoth"
Suffix.12="PPMute"
Suffix.13="PPLock"
Suffix.14="PPLdesc"
Suffix.15="PPRdesc"
Suffix.16="PPCtl"

Prefix="Ctl"

Key.1="RestoreState"
Key.2="AutoMinimize"
Key.3="InstanceName"
Key.4="CellsInLine"
Key.5="ShowMenu"
Key.6="ShowTitlebar"
Key.7="IconFile"
Key.8="LockName"
Key.9="MuteName"
Key.10="OffName"
Key.11="BothName"
Key.12="LFName"
Key.13="HFName"
Key.14="SpName"
Key.15="CtName"
Key.16="NarrowSliders"
Key.17="ShortSliders"
Key.18="ClientPP"
Key.19="TitlePP"
Key.20="MinMaxPP"
Key.21="MenuPP"
Key.22="SysMenuPP"
Key.23="FramePos"

Ctl.1="00"
Ctl.2="01"
Ctl.3="4d"
Ctl.4="43"
Ctl.5="44"
Ctl.6="42"
Ctl.7="41"
Ctl.8="45"
Ctl.9="46"
Ctl.10="40"
Ctl.11="4c"
Ctl.12="4b"
Ctl.13="4f"
Ctl.14="4e"

AssumeY=0
if translate(left(word(arg(1),1),2))="-Y" then AssumeY=1
if translate(left(word(arg(1),1),2))="-N" then AssumeY=-1

say "Update from older versions of LBMix by Lesha Bogdanow"
say "Scanning user ini file."
rc=SysIni("USER","ALL:","Apps")
if rc="ERROR:" then do
   say "Unable to access user ini file."
   exit 255
   end
do i=1 to Apps.0
   rc=SysIni("USER",Apps.i,"ALL:","Keys")
   if rc="ERROR:" then do
      say "Unable to access user ini file."
      exit 255
      end
   hits=0
   do j=1 to Keys.0
      if (left(Keys.j,3)="Ctl") then do
         t=substr(Keys.j,6)
         if (t="Mute")|(t="Left")|(t="Right") then hits=hits+1
         end
      if (hits>=3) then do
         say "Found a user ini file entry of an older version:" Apps.i
         rc=YNQuery("Would you like to import and remove it? (Y/N/A):")
         if left(rc,1)='Y' then do
            rc=MoveApp(INI,"USER",Apps.i)
            if rc="ERROR:" then do
               say "Unable to move ini entry."
               exit 255
               end
            say "Moved ini entry" Apps.i "from user ini to" INI
            end
         leave
         end
      end
   end

say "Scanning" INI"."
rc=SysIni(INI,"ALL:","Apps")
if rc="ERROR:" then do
   say "Unable to access" INI
   exit 255
   end
do i=1 to Apps.0
   rc=SysIni(INI,Apps.i,"ALL:","Keys")
   if rc="ERROR:" then do
      say "Unable to access" INI
      exit 255
      end
   do j=1 to Keys.0
      found=0
      k=1
      do while Key.k<>"KEY."k
         if Keys.j=Key.k then do
            found=1
            leave
            end
         k=k+1
         end
      k=1
      do while (found=0)&(Ctl.k<>"CTL."k)
         l=1
         do while Suffix.l<>"SUFFIX."l
            if Keys.j=insert(Prefix,insert(Ctl.k,Suffix.l)) then do
               found=1
               leave
               end
            l=l+1
            end         
         k=k+1
         end         
      if found=0 then do
         say "Found an unknown (probably outdated) ini file entry:" Apps.i":"Keys.j
         rc=YNQuery("Would you like to remove it? (Y/N/A):")
         if left(rc,1)='Y' then do
            rc=SysIni(INI,Apps.i,Keys.j,"DELETE:")
            if rc="ERROR:" then do
               say "Unable to remove ini entry."
               exit 255
               end
            say "Removed ini entry:" Apps.i":"Keys.j
            end
         end
      end
   end

exit 0

MoveApp:
   procedure
   Dst=arg(1)
   Src=arg(2)
   App=arg(3)

   rc=SysIni(Src,App,"ALL:","Keys")
   if rc="ERROR:" then return "ERROR:"
   do i=1 to Keys.0
      Data=SysIni(Src,App,Keys.i)
      if Data='' then return "ERROR:"
      rc=SysIni(Dst,App,Keys.i,Data)
      if rc="ERROR:" then return "ERROR:"
      rc=SysIni(Src,App,Keys.i,"DELETE:")
      if rc="ERROR:" then return "ERROR:"
      end
   return ""


YNQuery:
   procedure expose AssumeY
   if AssumeY=1 then return "Y"
   if AssumeY=-1 then return "N"
   say arg(1)
   pull rc
   rc=left(word(rc,1),1)
   if rc='A' then do
      AssumeY=1
      return "Y"
      end
   return rc
